osgShadow::ShadowedScene Class Reference

`#include <ShadowedScene>`

Inheritance diagram for osgShadow::ShadowedScene:

## Public Member Functions

| ShadowedScene (ShadowTechnique *st=0)
| ShadowedScene (const ShadowedScene &es, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Node (osgShadow, ShadowedScene)
virtual void | traverse (osg::NodeVisitor &nv)
void | setShadowSettings (ShadowSettings *ss)
template<class T>
void | setShadowSettings (const osg::ref_ptr< T > &ss)
ShadowSettings * | getShadowSettings ()
const ShadowSettings * | getShadowSettings () const
void | setShadowTechnique (ShadowTechnique *technique)
template<class T>
void | setShadowTechnique (const osg::ref_ptr< T > &ss)
ShadowTechnique * | getShadowTechnique ()
const ShadowTechnique * | getShadowTechnique () const
void | cleanSceneGraph ()
void | dirty ()
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
void | setReceivesShadowTraversalMask (unsigned int mask)
unsigned int | getReceivesShadowTraversalMask () const
void | setCastsShadowTraversalMask (unsigned int mask)
unsigned int | getCastsShadowTraversalMask () const
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ShadowedScene ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::ref_ptr< ShadowSettings > | _shadowSettings
osg::ref_ptr< ShadowTechnique > | _shadowTechnique
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

ShadowedScene provides a mechansim for decorating a scene that the needs to have shadows cast upon it.

## Constructor & Destructor Documentation

## ShadowedScene() [1/2]

osgShadow::ShadowedScene::ShadowedScene | ( | ShadowTechnique * | st = 0 | ) |

Referenced by META_Node(), and ShadowedScene().

## ShadowedScene() [2/2]

osgShadow::ShadowedScene::ShadowedScene | ( | const ShadowedScene & | es,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References ShadowedScene(), and osg::CopyOp::SHALLOW_COPY.

## ~ShadowedScene()

virtual osgShadow::ShadowedScene::~ShadowedScene | ( |  | ) |

protected virtual

## Member Function Documentation

## cleanSceneGraph()

void osgShadow::ShadowedScene::cleanSceneGraph | ( |  | ) |

Clean scene graph from any shadow technique specific nodes, state and drawables.

## dirty()

void osgShadow::ShadowedScene::dirty | ( |  | ) |

Dirty any cache data structures held in the attached ShadowTechnqiue.

## getCastsShadowTraversalMask()

unsigned int osgShadow::ShadowedScene::getCastsShadowTraversalMask | ( |  | ) | const

inline

deprecated, moved to ShadowSettings.

References _shadowSettings.

## getReceivesShadowTraversalMask()

unsigned int osgShadow::ShadowedScene::getReceivesShadowTraversalMask | ( |  | ) | const

inline

deprecated, moved to ShadowSettings.

References _shadowSettings.

## getShadowSettings() [1/2]

ShadowSettings * osgShadow::ShadowedScene::getShadowSettings | ( |  | ) |

inline

References _shadowSettings.

## getShadowSettings() [2/2]

const ShadowSettings * osgShadow::ShadowedScene::getShadowSettings | ( |  | ) | const

inline

References _shadowSettings.

## getShadowTechnique() [1/2]

ShadowTechnique * osgShadow::ShadowedScene::getShadowTechnique | ( |  | ) |

inline

References _shadowTechnique.

## getShadowTechnique() [2/2]

const ShadowTechnique * osgShadow::ShadowedScene::getShadowTechnique | ( |  | ) | const

inline

References _shadowTechnique.

## META_Node()

osgShadow::ShadowedScene::META_Node | ( | osgShadow | ,
|  | ShadowedScene | )

References ShadowedScene().

## releaseGLObjects()

virtual void osgShadow::ShadowedScene::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::Group.

## resizeGLObjectBuffers()

virtual void osgShadow::ShadowedScene::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::Group.

## setCastsShadowTraversalMask()

void osgShadow::ShadowedScene::setCastsShadowTraversalMask | ( | unsigned int | mask | ) |

inline

deprecated, moved to ShadowSettings.

References _shadowSettings.

## setReceivesShadowTraversalMask()

void osgShadow::ShadowedScene::setReceivesShadowTraversalMask | ( | unsigned int | mask | ) |

inline

deprecated, moved to ShadowSettings.

References _shadowSettings.

## setShadowSettings() [1/2]

template<class T>

void osgShadow::ShadowedScene::setShadowSettings | ( | const osg::ref_ptr< T > & | ss | ) |

inline

References osg::ref_ptr< T >::get(), and setShadowSettings().

Referenced by setShadowSettings().

## setShadowSettings() [2/2]

void osgShadow::ShadowedScene::setShadowSettings | ( | ShadowSettings * | ss | ) |

## setShadowTechnique() [1/2]

template<class T>

void osgShadow::ShadowedScene::setShadowTechnique | ( | const osg::ref_ptr< T > & | ss | ) |

inline

References osg::ref_ptr< T >::get(), and setShadowTechnique().

Referenced by setShadowTechnique().

## setShadowTechnique() [2/2]

void osgShadow::ShadowedScene::setShadowTechnique | ( | ShadowTechnique * | technique | ) |

## traverse()

virtual void osgShadow::ShadowedScene::traverse | ( | osg::NodeVisitor & |  | ) |

virtual

Traverse downwards : calls children's accept method with NodeVisitor.

Reimplemented from osg::Group.

## Member Data Documentation

## _shadowSettings

osg::ref_ptr<ShadowSettings> osgShadow::ShadowedScene::_shadowSettings

protected

Referenced by getCastsShadowTraversalMask(), getReceivesShadowTraversalMask(), getShadowSettings(), getShadowSettings(), setCastsShadowTraversalMask(), and setReceivesShadowTraversalMask().

## _shadowTechnique

osg::ref_ptr<ShadowTechnique> osgShadow::ShadowedScene::_shadowTechnique

protected

Referenced by getShadowTechnique(), and getShadowTechnique().

The documentation for this class was generated from the following file:

- ShadowedScene